package practice3;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.jdo.Query;
import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.NotPersistent;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.users.User;

@PersistenceCapable
public class Message implements Serializable {
	
	@PrimaryKey
	@Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
	private Key key;
	
	@Persistent
    private Key parentMessage;

	@Persistent
	private User user;
	
	@Persistent
	private String message;
	
	@Persistent
	private Date date;
	
	@NotPersistent
	private List<Message> replies;

	public Key getKey() {
        return key;
    }
	
	public Key getParentMessage() {
		return parentMessage;
	}

	public void setParentMessage(Key parentMessage) {
		this.parentMessage = parentMessage;
	}
	
	public void setUser(User user) {
		this.user = user;
	}
	
	public User getUser() {
		return user;
	}
	
	public void setMessage(String message) {
		this.message = message;
	}
	
	public String getMessage() {
		return message;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public Date getDate() {
		return date;
	}
	
	public List<Message> getReplies() {
		return replies;
	}

	public void setReplies(List<Message> replies) {
		this.replies = replies;
	}
	
	public void loadReplies(PersistenceManager pm) {
		Query query = pm.newQuery(Message.class);
		query.setFilter("parentMessage == parentParam");
		query.setOrdering("date desc");
		query.declareParameters(Message.class.getSimpleName() + " parentParam");
			
		List<Message> result = (List<Message>) query.execute(key);
		replies = new ArrayList<Message>(result);
	}
}
