package practice3.jdo;

import java.io.IOException;
import java.util.Date;

import javax.jdo.PersistenceManager;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import practice3.Message;
import practice3.PMF;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

public class CreateServlet extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    	
        String content = req.getParameter("message");
        Key parent = null;
        if(req.getParameter("messageId") != null) {
            parent = KeyFactory.createKey(Message.class.getSimpleName(), Long.parseLong(req.getParameter("messageId")));
		}
        
        UserService userService = UserServiceFactory.getUserService();
        User user = userService.getCurrentUser();
   
        PersistenceManager pm = PMF.get().getPersistenceManager();
        
        try {
        	if(content != null && !content.isEmpty()) {
        		Message message = new Message();
        		message.setParentMessage(parent);
        		message.setUser(user);
        		message.setMessage(content);
        		message.setDate(new Date());
        		pm.makePersistent(message);
        	}
        }
        finally {
            pm.close();
        }
        
        //RequestDispatcher rd = req.getRequestDispatcher("/messages");
        //rd.forward(req, resp);
        resp.sendRedirect("/");
    }
    
    public void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    	doGet(req, resp);
    }
}