package practice3.jdo;

import java.io.IOException;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.jdo.Query;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import practice3.Message;
import practice3.PMF;

import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

public class DeleteAllServlet extends HttpServlet {

	public void doGet(HttpServletRequest req, HttpServletResponse resp) throws IOException, ServletException {
		
		UserService userService = UserServiceFactory.getUserService();
        User user = userService.getCurrentUser();
        
       if(userService.isUserLoggedIn() && userService.isUserAdmin()) {
		
			PersistenceManager pm = PMF.get().getPersistenceManager();
			Query query = pm.newQuery(Message.class);
			
			try {
				List<Message> messages = (List<Message>) query.execute();
				pm.deletePersistentAll(messages);
			}
			finally {
				pm.close();
			}
		
        }
        
        resp.sendRedirect("/");
        
	}

}
