package practice3.jdo;

import java.io.IOException;

import javax.jdo.PersistenceManager;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import practice3.Message;
import practice3.PMF;

import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

public class DeleteServlet extends HttpServlet {
	public void doGet(HttpServletRequest req, HttpServletResponse resp) throws IOException, ServletException {
		
		long messageId = Long.parseLong(req.getParameter("messageId"));
		
		UserService userService = UserServiceFactory.getUserService();
        User user = userService.getCurrentUser();
        
        if(userService.isUserLoggedIn() && userService.isUserAdmin()) {
		
			PersistenceManager pm = PMF.get().getPersistenceManager();
			
			try {
				Key k = KeyFactory.createKey(Message.class.getSimpleName(), messageId);
		        Message m = pm.getObjectById(Message.class, k);
		        m.loadReplies(pm);
		        pm.deletePersistentAll(m.getReplies());
		        pm.deletePersistent(m);
			}
			finally {
				pm.close();
			}
		
        }
		
        resp.sendRedirect("/");
	}
}
