package practice3.jdo;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.jdo.PersistenceManager;
import javax.jdo.Query;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import practice3.Message;
import practice3.PMF;

import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;

public class ReadServlet extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    	
        UserService userService = UserServiceFactory.getUserService();
        User user = userService.getCurrentUser();
   
        PersistenceManager pm = PMF.get().getPersistenceManager();
        Query query = pm.newQuery(Message.class);
        query.setFilter("parentMessage == parentParam");
    	query.setOrdering("date desc");
    	query.declareParameters(Message.class.getSimpleName() + " parentParam");
        List<Message> messages = null;
        try {
            List<Message> result = (List<Message>) query.execute(null);
            messages = new ArrayList<Message>(result);
            for(Message message : messages) {
            	message.loadReplies(pm);
            }
        } finally {
            pm.close();
        }
            
        req.setAttribute("user", user);
        if(userService.isUserLoggedIn() && userService.isUserAdmin()) {
        	req.setAttribute("admin", true);
        }
        else {
        	req.setAttribute("admin", false);
        }
    	if(user == null) {
    		req.setAttribute("url", userService.createLoginURL("/"));
    	}
    	else {
    		req.setAttribute("url", userService.createLogoutURL("/"));
    	}
    	req.setAttribute("messages", messages);
    
    	RequestDispatcher rd = req.getRequestDispatcher("/guestbook.jsp");
    	rd.forward(req, resp);
    }
    
    public void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
    	doGet(req, resp);
    }
}