<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <style type="text/css">
            label {display: block;}
        </style>
        <title>Komentáře</title>
    </head>
    <body>
        <h1>Komentáře</h1>
        <p>
        <c:choose>
        <c:when test="${user != null}">
        	Jste přihlášen jako ${user.nickname}. <a href="${url}">Odhlásit se.</a>
        </c:when>
        <c:otherwise>
        	Nejste přihlášen. <a href="${url}">Přihlásit se.</a>
        </c:otherwise>
		</c:choose>
		</p>
        <h2>Vložit nový komentář</h2>
        <%-- data se odesilaji na servlet --%>
        <form action="/messages/create" method="GET">
            <div><textarea name="message" rows="3" cols="60"></textarea></div>
            <input type="hidden" name="token" value="${token}">
            <input type="hidden" name="tokenName" value="${tokenName}">
            <div><input type="submit" name="submit" value="Odeslat"></div>
        </form>

        <%-- tady se vypisuje vysledek konverze - v request scope se ocekava polozka s nazvem amount --%>
        <h2>Komentáře</h2>
        <c:if test="${admin}">
        <a href="/messages/deleteall">Vymazat všechny zprávy</a>
        </c:if>
        <ul>
        <c:forEach var="item" items="${messages}">
           <li>
           <div>Zpráva od uživatele:
           <c:choose>
           	<c:when test="${item.user != null}">
           		${item.user.nickname}
           	</c:when>
           	<c:otherwise>
           		Anonymous
           	</c:otherwise>
           </c:choose> 
           <c:if test="${admin}">
           <a href="/messages/delete?messageId=${item.key.id}">Vymazat zprávu</a>
           </c:if>
           </div>
           <div>${item.message}</div>
           <form action="/messages/create">
           		<textarea name="message"></textarea><br/>
           		<input type="hidden" name="messageId" value="${item.key.id}">
           		<input type="submit" name="submit" value="Reagovat">
           </form>
           <ul>
           <c:forEach var="reply" items="${item.replies}">
           		<li>
           			<div>Reply from user:
           			<c:choose>
           			<c:when test="${reply.user != null}">
           				${item.user.nickname}
           			</c:when>
           			<c:otherwise>
           				Anonymous
           			</c:otherwise>
           			</c:choose>
           			<c:if test="${admin}"> 
           			<a href="/messages/delete?messageId=${reply.key.id}">Vymazat reakci</a>
           			</c:if>
           		</div>
           		<div>${reply.message}</div>
           		</li>
           </c:forEach>
           </ul>
           </li>
        </c:forEach>
		</ul>
    </body>
</html>